/************************************************************************/
/*                                                                      */
/*                      16 channel software PWM                         */
/*                                                                      */
/*              Author: P. Dannegger                                    */
/*                                                                      */
/************************************************************************/
#include "main.h"
#include "pwm16.h"


void init( void )
{
  PORTA = 0xFF;		
  PORTB = 0xFF;		// pullups on

  pwm_init();
}


int main( void )
{
  s8 i, j;
  s8 steps = pwm_steps();		// only at run time possible

  init();
  sei();

  for(;;){
    for( i = -16; i <= steps; i++ ){
      _delay_ms( 25 );
      for( j = 0; j < 16; j++ )
	pwm_set( j, i + j );
    }
    for( i = 16 + steps; i; i-- ){
      _delay_ms( 25 );
      for( j = 0; j < 16; j++ )
	pwm_set( j, i - j );
    }
  }
}
